/*	Resources.h
 *
 *		The various resource identifiers
 */

/**********************************************************************

  YAAF is Copyright 1997-1999 by William Woody.

  Redistribution and use in source and binary forms, with or without 
  modification, are permitted provided that the following conditions 
  are met:

  Redistributions of source code must retain the above copyright notice, 
  this list of conditions and the following disclaimer.

  Neither the name of the copyright holder or other contributors may
  be used to promote products derived from this software without
  specific written prior permission.

  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, 
  EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES 
  OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND 
  NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS 
  BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN 
  ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN 
  CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE 
  SOFTWARE.
  
  Contact:   woody@alumni.caltech.edu
  Web page:  http://www.pandawave.com/yaaf/

**********************************************************************/

#ifndef PandaWave_RESOURCES
#define PandaWave_RESOURCES

#include <XConfig.h>

/************************************************************************/
/*																		*/
/*	Errors																*/
/*																		*/
/************************************************************************/

#define KErrorDupID				0x00810000

/************************************************************************/
/*																		*/
/*	Menu commands														*/
/*																		*/
/************************************************************************/

#define KMenuFileNew			101
#define KMenuFileOpen			102
#define KMenuFilePageSetup		103
#define KMenuFilePrint			104
#define KMenuExecuteScript		16
#define KMenuFileBuildFoundation	105
#define KMenuShowMeAllParsedTags 106
#define KMenuFileUpdateFormats	107

#define KMenuResourceCreate		401
#define KMenuResourceOpen		402
#define KMenuResourceInfo		403

#define KMenuWindowCatalog		301
#define KMenuWindowInspector	302

#define KMenuSplitRGBA			1002
#define KMenuMergeRGBA			1003
#define KMenuRecompress			1004
#define KMenuImportCameraMotion 1005
#define kMenuImportCINFile		1006


//#define KMenuMeshMoveHeights		2001
//#define KMenuMeshMoveMarkerLocal	2002
//#define KMenuMeshMoveMarkerWorld	2003
//#define KMenuMeshRotateMarker		2004
//#define KMenuMeshPlaceMarkers		2005

#define KMenuMeshLocalAxis			2001
#define KMenuMeshWorldAxis			2002

#define KMenuMeshShowColormap		2006
#define KMenuMeshShowTerrainType	2028
#define KMenuMeshShowRenderGrid		2007
#define KMenuMeshShowPhysicsGrid	2008
#define KMenuMeshShowMediaGrid		2009

#define KMenuMeshClickRenderGrid	2020
#define KMenuMeshClickPhysicsGrid	2021
#define KMenuMeshClickMediaGrid		2022
#define KMenuMeshClickNone			2029

#define KMenuMeshModifyRenderGrid	2023
#define KMenuMeshModifyPhysicsGrid	2024
#define KMenuMeshModifyMediaGrid	2025
#define KMenuMeshModifyMarkers		2030

#define KMenuMeshMarkersOff			2010
#define KMenuMeshMarkersOnly		2011
#define KMenuMeshBoundingBoxes		2012
#define KMenuMeshSimpleModels		2013
#define KMenuMeshComplexModels		2014

#define KMenuMeshEditHeader			2015
#define KMenuMeshMarkerPalette		2026
#define KMenuMeshScriptEditor		2027

#define KMenuMeshNewColormap		2016
#define KMenuMeshReplaceColormap	2017
#define KMenuMeshCollapseDetail		2018

#define KMenuMeshZeroPitchRoll		2003
#define KMenuMeshCopyPhysicalToRender 2004

#define KMenuFindTagFile		9801
#define KMenuReloadTag			9803
#define KMenuApplyTagChanges	9804
#define KMenuFindTag			9805
#define KMenuFindDuplicates		9806


/************************************************************************/
/*																		*/
/*	Window Resources													*/
/*																		*/
/************************************************************************/

#define KWindowTagFile			128
#define KWindowTextureStack 129
#define KWindowNewTag 130
#define KViewTextureStackElement 131
#define KWindowConfirmEditorClose 132
#define KViewTagEditHeader 133
#define KWindowPickTag 134
#define KWindowMonster 135
#define KWindowTagInfo 136
#define KWindowSkelModel 137
#define KWindowMeshHeader 138
#define KWindowSkelAnim 139
#define KWindowPickBone 140
#define KWindowRecompressTexture 141
#define KWindowMonsterAnimState 142
#define KWindowModelAttachments 143
#define KWindowTextureUsage 144
#define KWindowAnimationActions 145
#define KWindowProjectileFlags	146
#define KWindowProjectileGroupPart	147
#define KWindowPRGRPartSettings 147
#define KWindowSpriteFrame		148
#define KWindowSpriteDefinition 149
#define KWindowMonsterFlags 150
#define KWindowMonsterTerrain 151
#define KWindowMonsterSounds 152
#define KWindowProjectileDamage 153
#define KWindowObjectEffectModifiers 154
#define KWindowCollapseTerrainDetail 155
#define KWindowPhysicsLinear 156
#define KWindowPhysicsCylindrical 157
#define KWindowPhysicsSphericalSpring 158
#define KWindowPhysicsPointAttractor 159
#define KWindowPhysicsConverging 160
#define KWindowMeshEditor 161
#define KWindowMarkerEdit 162
#define KWindowPhysicsExplosiveGas 163
#define KWindowTagVersionUpdate 165
#define KWindowFindTag 166
#define KWindowModelShadows 167
#define KWindowMeshTools 168
#define KWindowNewMesh 169
#endif
