/*	XCursorUtil.h
 *
 *		This is the header file for the cursor utilities. This provides
 *	a portable mechanism for changing the mouse cursor
 */

/**********************************************************************

  YAAF is Copyright 1997-1999 by William Woody.

  Redistribution and use in source and binary forms, with or without 
  modification, are permitted provided that the following conditions 
  are met:

  Redistributions of source code must retain the above copyright notice, 
  this list of conditions and the following disclaimer.

  Neither the name of the copyright holder or other contributors may
  be used to promote products derived from this software without
  specific written prior permission.

  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, 
  EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES 
  OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND 
  NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS 
  BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN 
  ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN 
  CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE 
  SOFTWARE.
  
  Contact:   woody@alumni.caltech.edu
  Web page:  http://www.pandawave.com/yaaf/

**********************************************************************/

#ifndef PandaWave_XCURSORUTIL
#define PandaWave_XCURSORUTIL

#include <XConfig.h>

#ifdef __cplusplus
extern "C" {
#endif

/************************************************************************/
/*																		*/
/*	Cursor Utilities													*/
/*																		*/
/************************************************************************/

extern void			InitCursorAnimation(short *alist);

extern void			SetCursorID(short);
extern void			WaitCursor(void);
extern void			NormalCursor(void);

/************************************************************************/
/*																		*/
/*	Predefined Cursors													*/
/*																		*/
/************************************************************************/

#if (OPT_MACOS == 1) || (OPT_WINOS == 1)
#define	KNormalCursor	0
#define KIBeamCursor	1
#define KCrossCursor	2
#define KPlusCursor		3
#define KWatchCursor	4
#endif

#if OPT_XWIN == 1
#include <X11/cursorfont.h>

#define KNormalCursor	XC_left_ptr			/* X-Win Cursor Font Set	*/
#define KIBeamCursor	XC_xterm
#define KCrossCursor	XC_crosshair
#define KPlusCursor		XC_plus
#define KWatchCursor	XC_watch
#endif /* OPT_XWIN */


#ifdef __cplusplus
}
#endif

#endif /* PandaWave_XCURSORUTIL */
